# RabbitMQ tutorials ported to PHP's queue-interop

This is a [PHP tutorial](https://github.com/rabbitmq/rabbitmq-tutorials/tree/master/php) port to the [queue-interop](https://github.com/queue-interop/queue-interop#amqp-interop) family
of libraries.
These examples will work with any interop-compatible transport such as [enqueue/amqp-ext](https://github.com/php-enqueue/enqueue-dev/blob/master/docs/transport/amqp.md),
[enqueue/amqp-bunny](https://github.com/php-enqueue/enqueue-dev/blob/master/docs/transport/amqp_bunny.md),
or [enqueue/amqp-lib](https://github.com/php-enqueue/enqueue-dev/blob/master/docs/transport/amqp_lib.md).

## Requirements

As with other ports, to run the tutorials you'd need a RabbitMQ node started on localhost with all defaults.

### PHP 5.5+

You need `PHP 5.5` and one of the queue-interop compatible transport libraries.


### Composer

Then [install Composer](https://getcomposer.org/download/) per instructions on their site.

### Client Library

Then you can, for example, install `enqueue/amqp-bunny` using [Composer](https://getcomposer.org).

To do that install Composer and add it to your path, then run the following command
inside this project folder:

```bash
composer require enqueue/amqp-bunny
```
